/**
 * @file iedf_util.c
 * @brief Implicit-EDF Utilities (Implementation)
 * @author Simone Madeo
 * @version 0.1
 * @date 2011-10-10
 */

#include "util/iedf_util.h"

/* Deadline miss db */
uint16_t data_miss[] = {
                        1, 20,
                        1, 40,
                        1, 200,
                        1, 20,
                        1, 200,
                        1, 200,
                        1, 200,
                        1, 500,
                        1, 200,
                        1, 200,
                        1, 200,
                        1, 200,
                        1, 500,
                        1, 200,
                        1, 200,
                        2, 200,
                        1, 20,
                        1, 200,
                        1, 10,
                        2, 200,
                        2, 200,
                        1, 40,
                        1, 500,
                        1, 100,
                        1, 200,
                        1, 100,
                        1, 500,
                        1, 40,
                        1, 100,
                        2, 100,
                        1, 20,
                        1, 10,
                        1, 200,
                        1, 200,
                        1, 200,
                        1, 200,
                        1, 40,
                        1, 200,
                        2, 200,
                        2, 200,
                        1, 10,
                        1, 200,
                        1, 200,
                        1, 40,
                        1, 200,
                        1, 40,
                        1, 40,
                        1, 200,
                        3, 100,
                        1, 200,
                        1, 100,
                        1, 20,
                        2, 200,
                        1, 200,
                        1, 200,
                        1, 100,
                        2, 200,
                        1, 500,
                        1, 200,
                        1, 10,
                        1, 10,
                        1, 200,
                        1, 200,
                        1, 200,
                        1, 100,
                        3, 200,
                        1, 200,
                        1, 20,
                        1, 200,
                        1, 100,
                        1, 20,
                        1, 10,
                        1, 500,
                        1, 40,
                        1, 200,
                        1, 20,
                        1, 200,
                        1, 200,
                        1, 200,
                        1, 40,
                        2, 200,
                        3, 100,
                        1, 200,
                        1, 100,
                        1, 100,
                        2, 200,
                        1, 20,
                        1, 500,
                        1, 20,
                        1, 40,
                        1, 500,
                        1, 40,
                        2, 200,
                        4, 200,
                        3, 100,
                        2, 200,
                        1, 200,
                        3, 200,
                        1, 200,
                        2, 200,
                        1, 200,
                        1, 200,
                        1, 20,
                        2, 200,
                        1, 500,
                        2, 200,
                        5, 200,
                        1, 20,
                        1, 200,
                        10, 200,
                        2, 200,
                        1, 200,
                        1, 20,
                        1, 200,
                        2, 200,
                        1, 40,
                        1, 200,
                        1, 4,
                        7, 200,
                        1, 10,
                        2, 100,
                        1, 200,
                        5, 200,
                        1, 200,
                        1, 100,
                        1, 100,
                        1, 40,
                        1, 100,
                        2, 100,
                        1, 4,
                        1, 100,
                        1, 20,
                        1, 200,
                        1, 200,
                        1, 200,
                        1, 20,
                        1, 20,
                        8, 200,
                        2, 200,
                        1, 10,
                        1, 200,
                        5, 200,
                        1, 200,
                        1, 500,
                        8, 200,
                        1, 10,
                        1, 200,
                        1, 200,
                        1, 100,
                        2, 40,
                        1, 200,
                        3, 200,
                        5, 100,
                        9, 200,
                        3, 200,
                        1, 20,
                        1, 200,
                        3, 200,
                        2, 100,
                        4, 100,
                        10, 200,
                        1, 500,
                        1, 20,
                        1, 200,
                        1, 40,
                        1, 200,
                        1, 500,
                        1, 40,
                        1, 10,
                        1, 500,
                        1, 200,
                        1, 200,
                        1, 4,
                        1, 100,
                        3, 200,
                        1, 200,
                        1, 40,
                        1, 20,
                        1, 200,
                        3, 40,
                        5, 200,
                        1, 10,
                        6, 200,
                        1, 20,
                        1, 20,
                        10, 200,
                        1, 10,
                        1, 200,
                        1, 200,
                        1, 20,
                        1, 200,
                        1, 500,
                        1, 40,
                        2, 200,
                        1, 10,
                        4, 100,
                        2, 200,
                        1, 20,
                        9, 100,
                        1, 10,
                        1, 10,
                        2, 40,
                        4, 200,
                        1, 100,
                        1, 10,
                        2, 100,
                        5, 100,
                        1, 40,
                        1, 20,
                        1, 10,
                        1, 40,
                        1, 10,
                        2, 200,
                        3, 200,
                        1, 10,
                        1, 20,
                        1, 10,
                        2, 200,
                        1, 40,
                        1, 40,
                        1, 500,
                        1, 200,
                        2, 100,
                        1, 200,
                        4, 200,
                        2, 40,
                        1, 40,
                        2, 100,
                        1, 20,
                        1, 4,
                        1, 200,
                        1, 20,
                        2, 20,
                        1, 100,
                        2, 40,
                        1, 200,
                        1, 200,
                        1, 10,
                        1, 40,
                        1, 10,
                        1, 10,
                        4, 100,
                        1, 200,
                        1, 40,
                        6, 200,
                        1, 4,
                        2, 200,
                        1, 500,
                        1, 200,
                        9, 100,
                        1, 200,
                        6, 200,
                        1, 200,
                        1, 100,
                        11, 100,
                        7, 100,
                        1, 40,
                        6, 200,
                        8, 200,
                        1, 10,
                        2, 100,
                        1, 100,
                        2, 20,
                        1, 200,
                        1, 200,
                        1, 40,
                        1, 200,
                        3, 200,
                        1, 10,
                        1, 20,
                        2, 200,
                        1, 100,
                        2, 40,
                        1, 20,
                        1, 500,
                        1, 4,
                        2, 100,
                        10, 100,
                        1, 20,
                        1, 20,
                        1, 500,
                        3, 200,
                        2, 100,
                        3, 200,
                        1, 200,
                        1, 200,
                        1, 4,
                        1, 10,
                        1, 100,
                        6, 100,
                        1, 10,
                        1, 40,
                        1, 40,
                        1, 20,
                        6, 200,
                        8, 100,
                        1, 40,
                        1, 20,
                        2, 200,
                        1, 20,
                        1, 200,
                        1, 20,
                        20, 100,
                        2, 40,
                        1, 40,
                        1, 20,
                        1, 40,
                        4, 200,
                        1, 10,
                        2, 40,
                        1, 500,
                        1, 200,
                        1, 200,
                        1, 20,
                        2, 20,
                        4, 100,
                        1, 20,
                        1, 20,
                        1, 500,
                        4, 20,
                        1, 10,
                        3, 100,
                        1, 100,
                        1, 10,
                        2, 200,
                        1, 20,
                        1, 20,
                        1, 40,
                        3, 200,
                        1, 4,
                        1, 40,
                        1, 10,
                        3, 40,
                        1, 200,
                        1, 20,
                        3, 100,
                        1, 10,
                        7, 100,
                        1, 40,
                        2, 20,
                        5, 100,
                        1, 20,
                        1, 200,
                        8, 100,
                        6, 200,
                        1, 40,
                        1, 100,
                        1, 100,
                        3, 20,
                        2, 40,
                        1, 10,
                        1, 20,
                        1, 200,
                        1, 10,
                        1, 10,
                        1, 20,
                        1, 100,
                        1, 20,
                        1, 40,
                        1, 10,
                        1, 200,
                        5, 200,
                        1, 20,
                        4, 200,
                        1, 10,
                        2, 40,
                        3, 40,
                        1, 10,
                        1, 40,
                        1, 4,
                        3, 100,
                        2, 200,
                        1, 20,
                        1, 4,
                        2, 40,
                        1, 200,
                        1, 20,
                        1, 100,
                        1, 200,
                        22, 100,
                        2, 100,
                        1, 20,
                        1, 10,
                        1, 100,
                        1, 20,
                        1, 100,
                        1, 4,
                        1, 200,
                        1, 20,
                        4, 40,
                        4, 40,
                        3, 40,
                        1, 100,
                        1, 20,
                        2, 100,
                        1, 20,
                        2, 100,
                        7, 200,
                        1, 4,
                        6, 200,
                        13, 100,
                        1, 4,
                        1, 40,
                        5, 200,
                        1, 40,
                        3, 40,
                        6, 100,
                        1, 500,
                        2, 100,
                        2, 40,
                        2, 200,
                        11, 200,
                        1, 4,
                        1, 10,
                        1, 40,
                        2, 40,
                        4, 100,
                        3, 100,
                        2, 200,
                        8, 40,
                        4, 200,
                        1, 100,
                        1, 20,
                        1, 20,
                        16, 100,
                        1, 10,
                        1, 4,
                        1, 20,
                        1, 40,
                        3, 20,
                        1, 40,
                        6, 200,
                        2, 200,
                        4, 100,
                        6, 200,
                        1, 200,
                        7, 40,
                        3, 100,
                        8, 100,
                        12, 100,
                        1, 10,
                        2, 10,
                        1, 20,
                        1, 20,
                        1, 40,
                        1, 40,
                        1, 20,
                        1, 20,
                        1, 4,
                        3, 40,
                        1, 100,
                        1, 200,
                        1, 20,
                        1, 20,
                        10, 200,
                        1, 10,
                        9, 100,
                        1, 10,
                        1, 10,
                        1, 10,
                        2, 20,
                        3, 40,
                        1, 10,
                        1, 10,
                        1, 20,
                        3, 40,
                        4, 100,
                        1, 10,
                        5, 200,
                        2, 20,
                        1, 40,
                        7, 100,
                        1, 10,
                        7, 100,
                        1, 10,
                        2, 200,
                        1, 200,
                        1, 100,
                        1, 10,
                        2, 10,
                        1, 20,
                        1, 10,
                        1, 20,
                        1, 200,
                        10, 200,
                        1, 40,
                        8, 200,
                        4, 40,
                        1, 20,
                        4, 40,
                        1, 40,
                        1, 40,
                        1, 10,
                        1, 500,
                        10, 200,
                        11, 40,
                        2, 200,
                        1, 10,
                        1, 100,
                        1, 10,
                        1, 20,
                        1, 20,
                        2, 20,
                        1, 200,
                        2, 20,
                        1, 200,
                        1, 20,
                        1, 200,
                        17, 100,
                        8, 40,
                        1, 500,
                        1, 40,
                        1, 20,
                        8, 40,
                        1, 40,
                        1, 10,
                        22, 100,
                        1, 200,
                        1, 40,
                        7, 40,
                        3, 100,
                        16, 100,
                        8, 100,
                        1, 20,
                        1, 10,
                        1, 40,
                        2, 40,
                        1, 200,
                        3, 20,
                        12, 100,
                        3, 200,
                        1, 10,
                        1, 10,
                        1, 10,
                        1, 100,
                        1, 4,
                        6, 200,
                        1, 10,
                        10, 100,
                        14, 100,
                        6, 100,
                        1, 4,
                        9, 40,
                        2, 100,
                        1, 20,
                        1, 40,
                        1, 20,
                        2, 40,
                        1, 100,
                        1, 10,
                        1, 10,
                        1, 4,
                        1, 200,
                        2, 100,
                        9, 100,
                        1, 40,
                        5, 200,
                        2, 20,
                        3, 40,
                        1, 4,
                        1, 4,
                        1, 10,
                        1, 20,
                        1, 40,
                        1, 40,
                        6, 100,
                        1, 10,
                        3, 40,
                        1, 20,
                        1, 10,
                        4, 100,
                        1, 200,
                        1, 10,
                        9, 40,
                        6, 100,
                        1, 4,
                        1, 100,
                        1, 4,
                        13, 100,
                        1, 200,
                        8, 200,
                        1, 4,
                        1, 10,
                        1, 10,
                        1, 20,
                        5, 40,
                        5, 40,
                        1, 20,
                        1, 40,
                        1, 20,
                        1, 10,
                        2, 10,
                        1, 200,
                        9, 200,
                        1, 200,
                        5, 200,
                        1, 40,
                        4, 40,
                        2, 20,
                        1, 20,
                        1, 20,
                        1, 10,
                        4, 20,
                        2, 40,
                        1, 10,
                        1, 10,
                        1, 10,
                        1, 20,
                        9, 100,
                        4, 40,
                        1, 20,
                        2, 100,
                        2, 40,
                        2, 200,
                        1, 4,
                        2, 20,
                        1, 10,
                        1, 10,
                        3, 100,
                        4, 20,
                        1, 10,
                        2, 40,
                        3, 100,
                        1, 10,
                        5, 40,
                        1, 200,
                        4, 200,
                        1, 40,
                        2, 20,
                        1, 10,
                        5, 100,
                        1, 100,
                        2, 40,
                        1, 10,
                        1, 20,
                        1, 10,
                        2, 100,
                        1, 20,
                        1, 200,
                        3, 10,
                        3, 100,
                        1, 100,
                        1, 20,
                        1, 100,
                        7, 40,
                        1, 10,
                        1, 10,
                        1, 20,
                        1, 4,
                        1, 4,
                        1, 200,
                        1, 4,
                        1, 40,
                        1, 200,
                        1, 10,
                        14, 100,
                        1, 4,
                        10, 100,
                        1, 200,
                        1, 10,
                        8, 200,
                        3, 40,
                        2, 10,
                        1, 100,
                        1, 200,
                        1, 10,
                        3, 200,
                        1, 20,
                        1, 10,
                        3, 20,
                        5, 100,
                        6, 200,
                        38, 100,
                        1, 4,
                        2, 100,
                        6, 40,
                        1, 20,
                        1, 100,
                        9, 200,
                        2, 100,
                        1, 10,
                        1, 4,
                        1, 20,
                        1, 40,
                        6, 100,
                        6, 100,
                        1, 10,
                        7, 40,
                        1, 200,
                        11, 200,
                        1, 4,
                        6, 200,
                        3, 20,
                        2, 20,
                        1, 40,
                        1, 4,
                        1, 4,
                        11, 200,
                        1, 10,
                        1, 4,
                        51, 100,
                        3, 40,
                        2, 200,
                        1, 200,
                        4, 100,
                        1, 20,
                        1, 100,
                        1, 4,
                        2, 40,
                        5, 40,
                        1, 20,
                        4, 20,
                        4, 200,
                        1, 200,
                        2, 40,
                        1, 20,
                        2, 200,
                        4, 20,
                        1, 10,
                        1, 4,
                        16, 100,
                        1, 200,
                        1, 4,
                        2, 20,
                        2, 20,
                        4, 200,
                        1, 20,
                        8, 40,
                        3, 100,
                        1, 4,
                        1, 200,
                        10, 40,
                        1, 20,
                        1, 40,
                        5, 40,
                        1, 500,
                        1, 100,
                        1, 10,
                        3, 200,
                        4, 10,
                        10, 200,
                        1, 20,
                        5, 200,
                        1, 20,
                        1, 200,
                        3, 200,
                        1, 4,
                        5, 100,
                        1, 4,
                        51, 100,
                        9, 100,
                        9, 40,
                        1, 10,
                        4, 40,
                        1, 100,
                        1, 200,
                        8, 100,
                        10, 100,
                        1, 200,
                        2, 10,
                        1, 40,
                        3, 40,
                        1, 40,
                        2, 20,
                        2, 100,
                        6, 200,
                        2, 10,
                        2, 40,
                        2, 20,
                        11, 40,
                        1, 20,
                        1, 40,
                        1, 10,
                        44, 100,
                        2, 40,
                        2, 100,
                        1, 200,
                        1, 10,
                        1, 10,
                        22, 100,
                        9, 200,
                        1, 10,
                        28, 100,
                        1, 20,
                        1, 100,
                        3, 200,
                        3, 20,
                        6, 40,
                        1, 40,
                        1, 10,
                        1, 10,
                        2, 20,
                        1, 500,
                        1, 20,
                        6, 40,
                        4, 100,
                        1, 10,
                        4, 200,
                        1, 20,
                        31, 100,
                        2, 40,
                        1, 4,
                        1, 40,
                        3, 20,
                        1, 20,
                        2, 20,
                        1, 4,
                        7, 40,
                        1, 20,
                        1, 4,
                        3, 10,
                        1, 10,
                        1, 10,
                        1, 4,
                        4, 20,
                        1, 10,
                        1, 10,
                        1, 10,
                        1, 200,
                        1, 20,
                        5, 40,
                        2, 40,
                        1, 40,
                        1, 100,
                        1, 4,
                        4, 200,
                        16, 100,
                        6, 20,
                        1, 10,
                        1, 4,
                        4, 40,
                        28, 100,
                        1, 200,
                        1, 20,
                        10, 40,
                        8, 40,
                        1, 4,
                        6, 200,
                        1, 200,
                        5, 100,
                        8, 100,
                        1, 200,
                        20, 100,
                        3, 100,
                        2, 10,
                        1, 10,
                        1, 10,
                        1, 100,
                        1, 4,
                        1, 20,
                        6, 200,
                        2, 20,
                        1, 200,
                        1, 4,
                        1, 10,
                        31, 100,
                        2, 200,
                        3, 40,
                        4, 200,
                        1, 4,
                        2, 200,
                        1, 20,
                        1, 40,
                        3, 20,
                        1, 40,
                        6, 200,
                        7, 40,
                        4, 200,
                        1, 4,
                        3, 20,
                        19, 100,
                        1, 100,
                        1, 100,
                        3, 200,
                        1, 4,
                        2, 40,
                        1, 40,
                        3, 10,
                        3, 20,
                        7, 100,
                        1, 200,
                        4, 200,
                        4, 20,
                        9, 100,
                        1, 4,
                        8, 40,
                        1, 20,
                        1, 40,
                        1, 10,
                        12, 100,
                        1, 10,
                        1, 10,
                        1, 40,
                        3, 40,
                        1, 10,
                        1, 40,
                        5, 100,
                        6, 20,
                        12, 40,
                        1, 20,
                        4, 200,
                        1, 20,
                        1, 40,
                        3, 20,
                        2, 200,
                        8, 100,
                        16, 100,
                        1, 10,
                        1, 40,
                        12, 20,
                        1, 4,
                        1, 40,
                        4, 100,
                        1, 4,
                        23, 100,
                        16, 100,
                        1, 10,
                        1, 200,
                        1, 500,
                        2, 4,
                        1, 10,
                        1, 200,
                        1, 4,
                        3, 20,
                        2, 40,
                        1, 20,
                        24, 100,
                        5, 200,
                        1, 4,
                        5, 40,
                        3, 10,
                        1, 40,
                        1, 10,
                        1, 4,
                        1, 10,
                        2, 100,
                        2, 200,
                        8, 40,
                        1, 20,
                        3, 20,
                        1, 4,
                        7, 100,
                        2, 20,
                        1, 4,
                        1, 10,
                        1, 200,
                        3, 200,
                        1, 200,
                        7, 40,
                        1, 4,
                        22, 100,
                        3, 20,
                        5, 200,
                        3, 200,
                        1, 4,
                        1, 40,
                        1, 10,
                        1, 10,
                        3, 200,
                        7, 20,
                        1, 20,
                        1, 10,
                        12, 200,
                        1, 10,
                        4, 200,
                        6, 100,
                        3, 20,
                        5, 200,
                        2, 40,
                        24, 40,
                        1, 100,
                        4, 40,
                        5, 40,
                        1, 20,
                        1, 20,
                        2, 200,
                        6, 100,
                        1, 4,
                        22, 100,
                        13, 40,
                        1, 4,
                        10, 200,
                        1, 4,
                        2, 200,
                        4, 20,
                        2, 40,
                        1, 4,
                        1, 20,
                        1, 10,
                        30, 100,
                        3, 20,
                        13, 100,
                        18, 100,
                        5, 200,
                        2, 200,
                        2, 20,
                        1, 40,
                        19, 100,
                        9, 200,
                        6, 20
                        };

/* Timer2 setup */
void iedf_DEBUG_timer_set(void)
{
	/* TIMER2 */
    /* 40MHz --> 25ns */
	/* 25ns * 64  = 1.6us (ticktime) 0b10 */
	/* 25ns * 256 = 6.4us (ticktime) 0b11 */

	T2CON = 0;		        /* Stops the Timer2 and reset control reg */
	TMR2 = 0;		        /* Clear contents of the timer register	*/
	PR2 = 0xFFFF;		    /* Load the Period register -> 1ms @ 40MHz */

	T2CONbits.TCKPS = 0b10; /* 1:x prescaler value */
	T2CONbits.TON = 1;	    /* Start Timer2 */
}

/* Check the size of operation (x * y) */
uint8_t check_size(uint32_t x, uint32_t y)
{
    uint8_t i1 = 0, i2 = 0;
    uint32_t base = 1;
    
    while (base <= x && i1 != 32) {
        base = base << 1;
        i1++;
    }
    base = 1;
    while (base <= y && i2 != 32) {
        base = base << 1;
        i2++;
    }
    return i1 + i2 <= 32;
}

/* Calculate least common multiple between x and y */
uint32_t lcm(uint32_t x, uint32_t y)
{
    uint32_t temp, a = x, b = y;

    if (x == 0 || y == 0)
        return 0;
    if (b > a) {
        temp = a;
        a = b;
        b = temp;
    }
    while (b != 0) {
        temp = b;
        b = a % b;
        a = temp;
    }
    x = x / a;
    if (!check_size(x, y))
        return 0;
    return x * y;
}

/* Calculate ceiling(x / y) */
uint32_t ceiling(uint32_t x, uint32_t y)
{
    if (x % y == 0)
        return x / y;
    else
        return x / y + 1;
}

/* Calculate floor(x / y) */
int32_t get_floor(int32_t x, int32_t y)
{
    /* Note: check only dividend */
    if (x < 0)
        return x / y - 1;
    else
        return x / y;
}

/* Send a string to serial port */
void iedf_DEBUG_serial(const char *s)
{
    if (!IEDF_DEBUG_USE_SERIAL && iedf_get_status() != IEDF_STATUS_SNIFFER)
        return;
    iedf_debug_write((uint8_t*)s, strlen(s));
}

/* Convert an unsigned int to string. It returns byte size */
uint8_t iedf_DEBUG_serial_int2str(uint32_t x, char *str)
{
	uint8_t pos = 0, i;
    
    iedf_debug_sprint_u32(x, (char*)&str[0]);
    while (str[pos] == '0' && pos < 9)
        pos++;
        
    if (pos > 0)
        for (i = pos; i < 10; i++)
            str[i - pos] = str[i];
        
    return 10 - pos;
}

/* Send an unsigned int to serial port */
void iedf_DEBUG_serial_int(uint32_t x)
{
    uint8_t len;
    char str[13];
    
    if (!IEDF_DEBUG_USE_SERIAL && iedf_get_status() != IEDF_STATUS_SNIFFER)
        return;
    str[0] = '\r';
    str[1] = '\n';
    len = iedf_DEBUG_serial_int2str(x, (char*)&str[2]);
           
    iedf_debug_write((uint8_t*)&str[0], len + 2);
}

/* Send three unsigned int to serial port */
void iedf_DEBUG_serial_int3(uint32_t x, uint32_t y, uint32_t z)
{
    uint8_t len1, len2, len3;
	char str[36];

    if (!IEDF_DEBUG_USE_SERIAL && iedf_get_status() != IEDF_STATUS_SNIFFER)
        return;
    str[0] = '\r';
    str[1] = '\n';
    len1 = iedf_DEBUG_serial_int2str(x, (char*)&str[2]);
    str[len1 + 2] = ' ';
    len2 = iedf_DEBUG_serial_int2str(y, (char*)&str[len1 + 3]);
    str[len1 + len2 + 3] = ' ';
    len3 = iedf_DEBUG_serial_int2str(z, (char*)&str[len1 + len2 + 4]);
    iedf_debug_write((uint8_t*)&str[0], len1 + len2 + len3 + 4);
}

/* Send a double to serial port */
void iedf_DEBUG_serial_double(double x)
{
    uint8_t len;
    uint8_t i;
    char str[12];
    
    if (!IEDF_DEBUG_USE_SERIAL && iedf_get_status() != IEDF_STATUS_SNIFFER)
        return;
    str[0] = '\n';
    len = iedf_DEBUG_serial_int2str((int8_t)x, (char*)&str[1]);
    iedf_debug_write((uint8_t*)&str[0], len + 1);
    iedf_DEBUG_serial(".");
    
    for (i = 0; i < 4; i++) {
        x = x - (int8_t)x;
        x *= 10;
        len = iedf_DEBUG_serial_int2str((int8_t)x, (char*)&str[0]);
        iedf_debug_write((uint8_t*)&str[0], len);
    }
}

/* Return relative time between t1 and t2 */
uint16_t iedf_DEBUG_time(uint16_t t1, uint16_t t2)
{
    if (t2 >= t1)
        return t2 - t1;
    else
        return 65535 - t1 + t2;
}

/* Convert a double into a fraction */
void double2frac(double d, uint16_t *C, uint16_t *T)
{
    const double AccuracyFactor = 0.0005;
    uint16_t prevT, temp;
    double z;

    if (d == (uint16_t)d) {
        *C = (uint16_t)d;
        *T = 1;
        return;
    }
    if (d < 0.0001) {
        *C = 1;
        *T = 10000;
        return;
    }
    z = d;
    prevT = 0;
    *T = 1;
    do {
        z = 1.0 / (z - (uint16_t)z);
        temp = *T;
        *T = *T * (uint16_t)z + prevT;
        prevT = temp;
        *C = (uint16_t)(d * (*T) + 0.5);
    } while ((fabs(d - (double)*C / *T) > AccuracyFactor) && (z != (uint16_t)z));
}

/* UUniFast Algorithm - Generate the stream utilizations (C/T)
 * Return the total utilization */
double UUniFast(uint16_t n, double max_util, uint16_t *C, uint16_t *T)
{
	double sumU = max_util, nextSumU, u = 0;
    double val = 0;
	uint16_t i;

	for (i = 0; i < n-1; i++) {
		nextSumU = sumU * pow(((double)rand() / (double)RAND_MAX), 1.0 / (n-i));
		val = sumU - nextSumU;
		u += val;
        double2frac(val, &C[i], &T[i]);
		sumU = nextSumU;
	} 
    double2frac(sumU, &C[n-1], &T[n-1]);
    u += sumU;
    
	return u;
}

/* Initialize values for deadlline miss test */
uint32_t store_miss_values(uint16_t *dst, uint8_t umax, uint8_t iter)
{
    uint8_t i;
    uint32_t hyperperiod = 1;
    
    for (i = 0; i < N_NODES; i++) {
        dst[i * 3] = i + 1;
        memcpy(&dst[i * 3 + 1], &data_miss[umax * 200 + iter * 20 + i * 2], 4);
        hyperperiod = lcm(hyperperiod, dst[i * 3 + 2]);
    }
    
    return hyperperiod;
}
